/*
 * Copyright (C) 2004 by Linus McCabe
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef APPGUBED_H
#define APPGUBED_H

#include "wxClientGlobal.h"
#include "frmGubed.h"
#include "Breakpoint.h"

class appGubed: public wxApp
{
  private:
    virtual bool OnInit();
    virtual int appGubed::OnExit();

    ExecutionStates::State m_executionstate;
    BreakpointArray m_breakpointlist;
    wxArrayString m_bookmarklist;
    wxArrayString m_watchlist;
    unsigned int m_currentbp;
    unsigned int m_currentbm;
    long m_displaydelay;
    wxSocketLineHandler *m_connectionhandler;


  public:
    frmGubed *GetGubedWindow();
    void Connect();
    void Reconfigure();
    void SendCommand(const wxString&);
    void SendCommand(const wxString&, StringHash args);
    bool isConnected();
    bool isListening();
    void setConnectionState();
    void DebugMode(bool);

    wxArrayInt getFileBreakpoints(const wxString & filename);

    ExecutionStates::State executionState() { return m_executionstate; };
    void setExecutionState(ExecutionStates::State newstate);

//    void ConditionalBreakpoint(const wxString &expression, const wxString &filename, const wxString &cclass, const wxString &function, const wxString &type);
//    bool clearConditionalBreakpoint(const wxString &);
    void setBreakpoint(const Breakpoint& bp);
    void updateBreakpoint(const Breakpoint& bp);
    void clearBreakpoint(const Breakpoint& bp);
    void clearBreakpoint(int idx);
    void sendBreakpoints();
    void FindBreakpoint(int);

    void setBookmark(const wxString &, long);
    void clearBookmark(const wxString &, long);
    void FindBookmark(int);

    void AddWatch(wxString watch);
    void RemoveWatch(wxString watch);
    void SendWatches();

    void setDisplayDelay(long);
    long displayDelay() { return m_displaydelay; };
};

DECLARE_APP(appGubed);


#endif
