/*
 * Copyright (C) 2004 by Linus McCabe
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#ifndef frmConditionalBreakpoint_H
#define frmConditionalBreakpoint_H

#include "Breakpoint.h"

#include <wx/wx.h>

class frmConditionalBreakpoint: public wxDialog
{
  private:
    void OnCommand(wxCommandEvent&);
    void SetupControls(void);
    void OnClose(wxCloseEvent&);

    wxTextCtrl *m_expression;
    wxTextCtrl *m_class;
    wxTextCtrl *m_function;
    wxTextCtrl *m_filename;
    wxRadioButton *m_breakontrue;
    wxRadioButton *m_breakonchange;

  public:
    frmConditionalBreakpoint(wxFrame* parent);
    ~frmConditionalBreakpoint(void);

    wxString GetExpression();
    wxString GetClass();
    wxString GetFunction();
    Breakpoint::Type GetType();
    wxString GetFilename();

    void SetExpression(const wxString &expression);
    void SetClass(const wxString &cclass);
    void SetFunction(const wxString &func);
    void SetFilename(const wxString &filename);

    DECLARE_EVENT_TABLE()
};

#endif

