/*
 * Copyright (C) 2004 by Linus McCabe
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#ifndef NBSOURCES_H
#define NBSOURCES_H

#ifdef __WIN32__
	#include "../configmingw.h"
#else
	#include "../config.h"
#endif
#include "wxClientGlobal.h"
#include <wx/notebook.h>
#include <wx/hashmap.h>

#ifdef HAVE_STC
  #include "panSourceViewSTC.h"
#else
  #include "panSourceView.h"
#endif

WX_DECLARE_STRING_HASH_MAP(panSourceView*,  hmSources );

class nbSources: public wxNotebook
{
  private:
    // General functions
    void SetupControls(void);

    // Events
    //void OnClick(wxGridEvent& event);
    hmSources hmsSources;
    wxString strActiveSource;

  public:

    nbSources(wxWindow* parent, long style);

    bool AddSource(const wxString&, const wxString&);
    void CloseSource();
    void SetSource(const wxString &File, const wxString &Source);
//     void ParsedOk(const wxString&);
//     void UnParsed(const wxString&);
    void ToggleBookmark(long);
    //void FindBookmark(int);
    void ToggleBreakpoint(long);
    void SetBreakpoint(const wxString & strSource, long lngLineNum);
    void ClearBreakpoint(const wxString & strSource, long lngLineNum);
    //void FindBreakpoint(int);
    void SetActiveSourceLine(const wxString &, long);
    void gotoFileAndLine(const wxString &, long);
    void ShowActiveSourceLine();

    // void SetTip(const wxString&);

    DECLARE_EVENT_TABLE();
};

#endif
