/*
 * Copyright (C) 2004 by Linus McCabe
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#ifndef panSourceView_H
#define panSourceView_H

#include "wxClientGlobal.h"
#include <wx/wx.h>
#include <wx/grid.h>

class panSourceView: public wxPanel
{
  private:
    wxGrid *grdSourceView;
    long lngCurrentSourceLine;

    // General functions
    void SetupControls(void);

    bool CheckForWord(int, int, wxString&);

    // Events
    void OnLeftClick(wxGridEvent& event);
    void OnRightClick(wxGridEvent& event);
    void OnRangeSelect(wxGridRangeSelectEvent&);
    //void OnCellSelect(wxGridEvent&);
    void OnView(wxCommandEvent&);
    void OnWatch(wxCommandEvent&);
    void OnSet(wxCommandEvent&);
    void OnCondition(wxCommandEvent&);

    wxTextCtrl *txtSourceName;
    wxTextCtrl *txtCurrentline;
    wxTextCtrl *txtTotallines;

    wxString strSourcename;
    wxString strIdentifier;
    wxString strPopupWord;

    //int intPage;
    int intFontWidth;

  public:
    bool SetIdentifier(const wxString &);
    void SetSource(wxString);
    void ShowActiveSourceLine();
    void ShowSourceLine(long);
    void ToggleBookmark(long);
    void ToggleBreakpoint(long);
    void SetBreakpoint(long, bool);
    void ClearBreakpoint(long, bool);
    void SetActiveSourceLine(long);
    void SetRowColour(long);

    const wxString &GetFilename() { return strSourcename;};

    //void SetPage(int intPage);
    int GetPage();

    panSourceView(wxWindow* parent, wxWindowID id, const wxPoint& pos, const wxSize& size, const wxString&);
    DECLARE_EVENT_TABLE();
};

enum {
  cmd_variable_inspect = 5999,
  cmd_variable_watch ,
  cmd_variable_set,
  cmd_variable_break
};

#endif
