/*
 * Parts of code from lineread.h by Brian Victor
 * Classes to process one line at a time from sockets
 *
 * Copyright 2003 Brian Victor
 * Released under the terms of the wxWindows license
 *
*/

#ifndef SOCKLINESOCKET_H
#define SOCKLINESOCKET_H

#include "wxClientGlobal.h"
#include <wx/event.h>
#include <wx/socket.h>
#include <wx/hashmap.h>

                              
class wxSocketBase;
class wxSocketEvent;

class /*WXDLLEXPORT*/ wxSocketLineHandler : public wxEvtHandler {

   public:
      wxSocketLineHandler();
      ~wxSocketLineHandler();
      void HandleLine(int sockid, const wxString &, const wxString &);
      void OnSocketRead(wxSocketEvent& ev);
      void SendCommand(const wxString& command, char * firstarg, ...);
      void SendCommand(const wxString& command, StringHash args);
      bool isConnected() { return m_socket != NULL; };
      bool isListening();
      void Connect();

   private:
     wxSocketServer *m_server;
     wxSocketClient *m_client;
     wxSocketBase *m_socket;
     wxIPV4address getAddress();
     StringHash ParseArgs(const wxString &args);
     wxString phpSerialize(StringHash args);
     
     wxString m_buf;
     long     m_datalen;
     wxString strCommand;

     enum ids {
       Server = 10001,
       Client,
       Socket
     };

   DECLARE_EVENT_TABLE();
};

#endif
