/*
 * Copyright (C) 2004 by Linus McCabe
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include <wx/wx.h>
#include "wxClientGlobal.h"
 
StringHash CompileHash(char* a, ...)
{
  StringHash ca;
  char *next;
  
  va_list l_Arg;
  va_start(l_Arg,a);
  
  next = a;
  while(next)
  {
    
    ca[(wxString)next] = (wxString)va_arg(l_Arg, char*);
    wxLogDebug(_T("wxClientGlobal, CompileHash: Added arg/valuepair '%s' : '%s'"), next, ca[next].Left(30).c_str());
    
    next = va_arg(l_Arg, char*);
  }
  
  va_end(l_Arg);
  
  return ca;
  
}
