/*
 * Copyright (C) 2002 - 2004 by Linus McCabe
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include <iostream>
#include <string>
using namespace std;
#include "gbdLog.h"

gbdLog logOutput;

gbdLog::gbdLog()
{
  intCurrentLevel = 0;
  intVerboseLevel = 0;
}

void gbdLog::SetVerbosityLevel(int intLevel)
{
  intVerboseLevel = intLevel;
}

int gbdLog::GetVerbosityLevel()
{
  return intVerboseLevel;
}

gbdLog& gbdLog::operator<(int intNewLevel)
{
  intCurrentLevel = intNewLevel;
  return *this;
}

gbdLog& gbdLog::operator<<(int intNumber)
{
  if(intCurrentLevel >= intVerboseLevel)
  {

    if(intCurrentLevel >= LOG_LEVEL_ERROR)
      cerr << intNumber << flush;
    else
      cout << intNumber << flush;
  }
  return *this;
}

gbdLog& gbdLog::operator<<(const char* pchString)
{
  if(intCurrentLevel >= intVerboseLevel)
  {

    if(intCurrentLevel >= LOG_LEVEL_ERROR)
      cerr << pchString << flush;
    else
      cout << pchString << flush;
  }
  return *this;
}

gbdLog& gbdLog::operator<<(const string &strString)
{
  if(intCurrentLevel >= intVerboseLevel)
  {

    if(intCurrentLevel >= LOG_LEVEL_ERROR)
      cerr << strString.c_str() << flush;
    else
      cout << strString.c_str() << flush;
  }
  return *this;
}
