/*
 * Copyright (C) 2002 - 2004 by Linus McCabe
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef _GBDLOG_H_
#define _GBDLOG_H_

#include <string>
using namespace std;

#define LOG_LEVEL_ERROR		4
#define LOG_LEVEL_INFO		3
#define LOG_LEVEL_VERBOSE	2
#define LOG_LEVEL_DEBUG		1

#define LOG_ERROR	(logOutput  < LOG_LEVEL_ERROR) <<
#define LOG_INFO	(logOutput  < LOG_LEVEL_INFO) <<
#define LOG_VERBOSE (logOutput  < LOG_LEVEL_VERBOSE) <<
#define LOG_DEBUG	(logOutput  < LOG_LEVEL_DEBUG) <<

class gbdLog
{
  public:
    gbdLog();
    gbdLog& operator<<(int);
    gbdLog& operator<<(const char*);
    gbdLog& operator<<(const string &);
    gbdLog& operator<(int);

    void SetVerbosityLevel(int);
    int GetVerbosityLevel();

  private:
    int intCurrentLevel;
    int intVerboseLevel;

};


extern gbdLog logOutput;

#endif
