/*
 * Copyright (C) 2002 - 2004 by Linus McCabe
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */


#ifndef _GBDNETWORK_H_
#define _GBDNETWORK_H_

#include <string>
using namespace std;

#ifdef __WIN32__
  #include <winsock.h>
#else
  #include <sys/socket.h>
  #include <sys/time.h>
  #include <sys/types.h>
  #include <netinet/in.h>
  #include <unistd.h>
#endif

class gbdNetwork
{

  public:
    gbdNetwork(int intPort);
    ~gbdNetwork();

    // gbdNetwork interface
    void Accept();
    bool IsConnected();

    void SendCommand(string);

    void AddSockets(fd_set*);
    void HandleInput(fd_set*);
    int GetMaxSocket();
    string gbdNetwork::FlushBuffer();
    void gbdNetwork::SendData(string data);

  protected:
    // gbdNetwork variables
    int	intThisPort;

    int intListen;
    int	intComm;

    fd_set* fdpMaster;

    struct sockaddr_in addrRemote;
    string m_buffer;


};


#endif	//_GBDNETWORK_H_

