/*
 * Copyright (C) 2002 - 2004 by Linus McCabe
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef GBDSERVER_H
#define GBDSERVER_H

#define PROXYVERSION "0.1.0"
#define GUBEDRELEASE "0.2.2"

// keep windows.h from #defining min() max() macros
#ifdef WIN32
  #define NOMINMAX
#endif

#include "gbdNetwork.h"
#include "gbdLog.h"

#include <iostream>
#include <string>
using namespace std;

#ifdef __WIN32__
  #include <winsock.h>
  #define SETTINGSPATH "USERPROFILE"
#else
  #include <sys/time.h>
  #include <sys/types.h>
  #include <sys/socket.h>
  #include <unistd.h>
  #include <signal.h>

  #define SETTINGSPATH "HOME"
#endif

#define SETTINGSFILE "/.gubedproxy"

#ifndef max
#define max(a, b) (((a) > (b)) ? (a) : (b))
#endif

void Quit(int);
void ProcessCommand(string&);
void ProcessAccept(int, bool);
void HaveData(int);

void ShowHelp();
void ShowArgHelp();
void ShowStartupInfo();

void ParseArgs(int argc, char**argv);
void ReadSettings();
bool ParseConfig(const char*, const char*);

extern gbdNetwork *nwDebug;
extern gbdNetwork *nwCommand;

#endif
