<?php
/***********************************************************************
 *                                                                      **
**                          Gubed - PHP Debugger                        **
**                      (c) 2002 - 2004 Linus McCabe                    **
**                                                                      **
** This program is free software; you can redistribute it and/or modify **
** it under the terms of the GNU General Public License as published by **
** the Free Software Foundation; either version 2 of the License, or    **
** (at your option) any later version.                                  **
**                                                                      **
** This program is distributed in the hope that it will be useful,      **
** but WITHOUT ANY WARRANTY; without even the implied warranty of       **
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        **
** GNU General Public License for more details.                         **
**                                                                      **
** You should have received a copy of the GNU General Public License    **
** along with this program; if not, write to the Free Software          **
** Foundation, Inc.                                                     **
** 59 Temple Place, Suite 330                                           **
** Boston, MA  02111-1307  USA                                          **
**                                                                      **
************************************************************************/

   // The recommended place to change your settings is in localsettings.php,
   // this file contains defaults only

   ob_implicit_flush();

   // Read settings from localsettings.php if it exists
   if(file_exists(dirname(__FILE__).'/localsettings.php'))
     include(dirname(__FILE__).'/localsettings.php');

   // If server is not set, expect it to be localhost
   if(!isset($gbdDebugServer))
      $gbdDebugServer = $_SERVER['REMOTE_ADDR'];

   // Default Gubed port
   if(!isset($gbdDebugPort))
      $gbdDebugPort = 8016;

   // Default cache directory
   if(!isset($GLOBALS['gbd']['cachedir'])) {
      $GLOBALS['gbd']['cachedir'] = tempnam("/tmp/gubedcache", "");
   }

   // Version information
   $gbdProtocolVersion = '0.0.12';
   $gbdVersion = '0.2.2';

   set_time_limit(3600);
   $GLOBALS['gbd']['gbdPort'] = $gbdDebugPort;
   $GLOBALS['gbd']['gbdServer'] = $gbdDebugServer;

   if (!defined('PATH_SEPARATOR'))
      define('PATH_SEPARATOR', strtoupper(substr(PHP_OS, 0, 3) == 'WIN') ? ';' : ':');

   // Delay when tracing
   if(!isset($GLOBALS['gbd']['displaydelay']))
      $GLOBALS['gbd']['displaydelay'] = 300000;

   // Cachedir
   if(!isset($GLOBALS['gbd']['cachedir']))
      $GLOBALS['gbd']['cachedir'] = '';

   // If default tmpname was used to get tempdir, it will be a file right now...
   if(is_file($GLOBALS['gbd']['cachedir'])) {
      unlink($GLOBALS['gbd']['cachedir']);
      $GLOBALS['gbd']['cachedir'] = dirname($GLOBALS['gbd']['cachedir']) . DIRECTORY_SEPARATOR . 'gubedcache';
   }
 
   if($GLOBALS['gbd']['cachedir'] != '' && !file_exists($GLOBALS['gbd']['cachedir']))
      mkdir($GLOBALS['gbd']['cachedir']);

   if($GLOBALS['gbd']['cachedir'] != '' && substr($GLOBALS['gbd']['cachedir'], -strlen(DIRECTORY_SEPARATOR)) != DIRECTORY_SEPARATOR )
      $GLOBALS['gbd']['cachedir'] .= DIRECTORY_SEPARATOR;
      
   // Gubed internal time to deduct from script time
   if(!isset($GLOBALS['gbd']['gubedtime'])) {
      $GLOBALS['gbd']['gubedtime'] = 0;
      $GLOBALS['gbd']['parsetime'] = 0;
   }
      
   if(!isset($GLOBALS['gbd']['unparsed']))
      $GLOBALS['gbd']['unparsed'] = Array();
      
   // At certain pointes, the errorhandler should return immediately
   if(!isset($GLOBALS['gbd']['gbdNoHalt']))
      $GLOBALS['gbd']['gbdNoHalt'] = false;
      
   // Temporarily turns off debugging
   if(!isset($GLOBALS['gbd']['gbdNoDbg']))
      $GLOBALS['gbd']['gbdNoDbg'] = false;

   // Keeps track of wether current script should be required or included...
   if(!isset($GLOBALS['gbd']['gbdScriptRequire']))
      $GLOBALS['gbd']['gbdScriptRequire'] = 'include';

   // Breakpoints
   if(!isset($GLOBALS['gbd']['breakpoints']))
      $GLOBALS['gbd']['breakpoints'] = Array();
   if(!isset($GLOBALS['gbd']['conditionalbreakpoints']))
      $GLOBALS['gbd']['conditionalbreakpoints'] = Array();

   // Global no-debug files
   if(!isset($GLOBALS['gbd']['gbdNoDebug']))
      $GLOBALS['gbd']['gbdNoDebug'] = Array();
               
   // Keeps track of what files are included once
   if(!isset($GLOBALS['gbd']['gbdIncludedOnce']))
      $GLOBALS['gbd']['gbdIncludedOnce'] = Array();
   
   // Keeps track of witch variables are watched
   if(!isset($GLOBALS['gbd']['gdbView']))
      $GLOBALS['gbd']['gdbView'] = Array();
      
   // Keeps track of included scripts
   if(!isset($GLOBALS['gbd']['gdbScripts']))
      $GLOBALS['gbd']['gdbScripts'] = Array();
      
   // Counter - keeps track of recursedepth
   if(!isset($GLOBALS['gbd']['gbdCount']))
      $GLOBALS['gbd']['gbdCount'] = 0;
   
   $GLOBALS['gbd']['gbdErrorMask'] = E_ALL;

   $GLOBALS['gbd']['gbdSocket'] = 0;

   // Backtrace array
   $GLOBALS['gbd']['backtrace'] = Array();
   
   // When running, the command queue is only checked so so often..
   $GLOBALS['gbd']['tickcount'] = 0;
   
   // Input buffer
   $GLOBALS['gbd']['gbdBuffer'] = '';
   $GLOBALS['gbd']['gbdCommand'] = '';

?>
