<?php
/***********************************************************************
 *
**                          Gubed - PHP Debugger                        
**                     (c) 2002 - 2004 Linus McCabe                     
**                                                                      
** This program is free software; you can redistribute it and/or modify 
** it under the terms of the GNU General Public License as published by 
** the Free Software Foundation; either version 2 of the License, or    
** (at your option) any later version.                                  
**                                                                      
** This program is distributed in the hope that it will be useful,      
** but WITHOUT ANY WARRANTY; without even the implied warranty of       
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        
** GNU General Public License for more details.                         
**                                                                      
** You should have received a copy of the GNU General Public License    
** along with this program; if not, write to the Free Software          
** Foundation, Inc.                                                     
** 59 Temple Place, Suite 330                                           
** Boston, MA  02111-1307  USA                                          
**
*************************************************************************/

   define('gbdBLOCK', 0);
   define('gbdONESTATEMENT', 1);
   define('gbdCOLONIF', 2);

   // Defined in PHP5, but not PHP4
   if(!defined('T_CATCH'))
         define('T_CATCH', -1);
   if(!defined('T_THROW'))
         define('T_THROW', -1);
   if(!defined('T_PUBLIC'))
         define('T_PUBLIC', -1);
   if(!defined('T_PRIVATE'))
         define('T_PRIVATE', -1);
   if(!defined('T_INTERFACE'))
         define('T_INTERFACE', -1);
   if(!defined('T_ABSTRACT'))
         define('T_ABSTRACT', -1);
   if(!defined('T_PROTECTED'))
         define('T_PROTECTED', -1);
   if(!defined('T_TRY'))
         define('T_TRY', -1);
   if(!defined('T_ML_COMMENT'))
         define('T_ML_COMMENT', -1);
   if(!defined('T_DOC_COMMENT'))
         define('T_DOC_COMMENT', -1);

   function gbdParseCode($gbdThisScript, $gbdPhpCode, $debug, &$returninfo, $gbdRedefineFuncs) {
      global $gbdOpenTags;
      
      if($GLOBALS['gbd']['cachedir'] != '' && file_exists($GLOBALS['gbd']['cachedir'] . md5($gbdThisScript)) && filemtime($GLOBALS['gbd']['cachedir'] . md5($gbdThisScript)) > filemtime($gbdThisScript) && !$debug && filemtime($GLOBALS['gbd']['cachedir'] . md5($gbdThisScript)) > filemtime(__FILE__) && $gbdThisScript != '~') {
         $gbdThisScript =$GLOBALS['gbd']['cachedir'] . md5($gbdThisScript);
         Header("X-Gubed-UsedCache: {$gbdThisScript}", false);
         return gbdReadScript($gbdThisScript);
      }

      // Take care of <?xml in html files
      $gbdPhpCode = preg_replace("/^(<\\?xml .* ?>)/","<?php echo '\\1'; ?>",  $gbdPhpCode);

//       echo "<pre>" . htmlentities($gbdPhpCode); die();
      $gbdTempTimer = gbdGetmicrotime();
      $gbdOpenTags = 0;
      $gbdTokens = token_get_all($gbdPhpCode);
      if($gbdRedefineFuncs === true)
         $gbdRedefineFuncs = 'gbdRedef';

      // Stupid bug workaround #1
      $gbdTries = 0;
      while(!is_array($gbdTokens[0])
         || (is_array($gbdTokens[0]) && !in_array($gbdTokens[0][0], Array(T_OPEN_TAG, T_OPEN_TAG_WITH_ECHO, T_INLINE_HTML)))
      ) {
         usleep(200);
         $gbdTokens = token_get_all($gbdPhpCode);
         if($gbdTries++ > 10) {
            echo "PHP Bug error:\n";
            print_r($gbdTokens);
            exit(5);
         }
      }

      $gbdPHPNewCode = '<?php <gbdGubed> { ?>' 
                                  . gbdParseBlock($gbdThisScript, $gbdTokens, gbdBLOCK, $debug, $gbdRedefineFuncs) ;
      if($gbdOpenTags <= 0)
         $gbdPHPNewCode .= '<?php } ?>';

      if($debug)
         $returninfo['gubedadded'] = $gbdPHPNewCode;

      $gbdPHPNewCode = preg_replace(
                  Array(
                     "/<gbdEndGubed>/",
                     "/<gbdGubed>([\\s@]*)([^'\[\"();?\\s]*)/",
                     "/<gbdGubed2>/",
                     "/\/\* STOP \*\//",
                     ),
                  Array(
                     ";",
                     $debug ? "if(gubed('\\2')) \\1\\2"   : "if(eval(gbdGubed('$gbdThisScript',__LINE__, gbdGet_defined_vars(get_defined_vars(), (isset(\$this) ? \$this : NULL)), '\\2'))) \\1\\2",
                     $debug ? "gubed() ? false : " : "!eval(gbdGubed('$gbdThisScript',__LINE__, gbdGet_defined_vars(get_defined_vars(), (isset(\$this) ? \$this : NULL)), '')) ? false : ",
                     $debug ? "breakpoint();" : "gbdHandleBreakPoint('$gbdThisScript',__LINE__, gbdGet_defined_vars(get_defined_vars(), (isset(\$this) ? \$this : NULL)));",
                     ),
                  $gbdPHPNewCode);

      unset($gbdOpenTags);
      if($GLOBALS['gbd']['cachedir'] != '' && !$debug  && $gbdThisScript != '~') {
         $fp = fopen($GLOBALS['gbd']['cachedir'] . md5($gbdThisScript), 'w');
         if($fp) {
            fputs($fp, $gbdPHPNewCode);
            fclose($fp);    
          }
      }
      $GLOBALS['gbd']['parsetime'] += gbdGetmicrotime() - $gbdTempTimer;
      $GLOBALS['gbd']['gubedtime'] += gbdGetmicrotime() - $gbdTempTimer;
      return $gbdPHPNewCode;
   }
   
   function gbdParseBlock($gbdThisScript, &$gbdTokens, $gbdOne, $debug, $gbdRedefineFuncs) {
      global $gbdOpenTags;
      $gbdPHPNewCode = '';
      $gbdPrevToken = "";
      
      while(list($k, $token) = each($gbdTokens)) {

         if(is_array($token)) {
//             print(token_name($token[0]) . ": '" . htmlentities($token[1]) . "'\n");

            switch($token[0]) {
               case T_INLINE_HTML:
               case T_CONSTANT_ENCAPSED_STRING:
               case T_DEFAULT:
               case T_LOGICAL_AND: 
               case T_ABSTRACT:
                  $gbdPHPNewCode .= $token[1];
                  break;
               
               case T_PROTECTED:
               case T_PUBLIC:
               case T_PRIVATE:
                  if( gbdIfNextIs($gbdTokens, $whitespace, T_VARIABLE) ) {
                     $gbdPHPNewCode .= $token[1]. $whitespace.gbdAddUntilNext($gbdThisScript, $gbdTokens, ';') . ';';
                     next($gbdTokens);
                  } else
                     $gbdPHPNewCode .= $token[1].$whitespace;
                  break;
               
               case T_EXIT:
                  $gbdPHPNewCode .= '<gbdGubed> { $GLOBALS[\'gbd\'][\'buffer\'] = ob_get_contents(); ob_end_clean(); ' . $token[1] . gbdAddBlock($gbdThisScript, $gbdTokens, '', ';') . '2';
                  $gbdPHPNewCode = substr($gbdPHPNewCode, 0, strlen($gbdPHPNewCode ) -1) . ' }<gbdEndGubed> ;'; 

                  if($gbdOne == gbdONESTATEMENT)
                     return $gbdPHPNewCode;
                  break;
                  
                  
               case T_STRING:
                  if(isset($GLOBALS['gbd']['gbdSession']) && $GLOBALS['gbd']['gbdSession'] && trim(strtolower($token[1])) == 'header') {
                     $gbdTmp = gbdAddBlock($gbdThisScript, $gbdTokens, '', ';');
                     if(preg_match("/Location:.*/", $gbdTmp) && !preg_match("/Location:\\s*.*:\\/\\/.*/", $gbdTmp)) {
                        $gbdPHPNewCode .= '<gbdGubed> gbdRelocate' . $gbdTmp;
//                         echo $gbdPHPNewCode . '<br>'; ob_flush();
                     } else
                        $gbdPHPNewCode .= '<gbdGubed> Header'  . $gbdTmp;
                        $gbdPHPNewCode = substr($gbdPHPNewCode, 0, strlen($gbdPHPNewCode ) -1) . ' <gbdEndGubed> ;'; 
                     
                  /*} else if (trim(strtolower($token[1])) == 'exit' || trim(strtolower($token[1])) == 'die') {
                     $gbdPHPNewCode .= '<gbdGubed>' . '{$GLOBALS[\'gbd\'][\'buffer\'] = ob_get_contents(); ' . $token[1] . gbdAddBlock($gbdThisScript, $gbdTokens, '', ';') . '}';
                     $gbdPHPNewCode = substr($gbdPHPNewCode, 0, strlen($gbdPHPNewCode ) -1) . ' <gbdEndGubed> ;'; 
                  */   
                  // Is this needed?
                  //} else if(trim(strtolower($token[1])) == 'flush') {
                  //   $gbdPHPNewCode .= '/*' . $token[1] . gbdAddBlock($gbdThisScript, $gbdTokens, '', ';') . '*/';
                  } else {
                     $gbdPHPNewCode .= '<gbdGubed>' . $token[1] . gbdAddBlock($gbdThisScript, $gbdTokens, '', ';');
                     $gbdPHPNewCode = substr($gbdPHPNewCode, 0, strlen($gbdPHPNewCode ) -1) . ' <gbdEndGubed> ;'; 
                  }
                  if($gbdOne == gbdONESTATEMENT)
                     return $gbdPHPNewCode;
                  break;

               case T_EVAL: 
               case T_ARRAY_CAST:
               case T_ARRAY:
               case T_DECLARE:
               case T_NEW:
               case T_INC:
               case T_DEC:
               case T_ISSET:
               case T_VARIABLE:
               case T_ECHO:
               case T_PRINT:
               case T_LIST:
               case T_UNSET:
               case T_EMPTY:
               case T_BREAK;
               case T_CONTINUE;
                  $gbdPHPNewCode .= '<gbdGubed>' . $token[1] . gbdAddBlock($gbdThisScript, $gbdTokens, '', ';');
                  $gbdPHPNewCode = substr($gbdPHPNewCode, 0, strlen($gbdPHPNewCode ) -1) . ' <gbdEndGubed> ;'; 

                  if($gbdOne == gbdONESTATEMENT)
                     return $gbdPHPNewCode;
                  break;
               
               case T_CASE:
                  $gbdPHPNewCode .= $token[1]. gbdAddUntilNext($gbdThisScript, $gbdTokens, Array(':', ';')) . ':';
                  next($gbdTokens);
                  break;
                     
               case T_GLOBAL:
               case T_CONST:
               case T_VAR:
               case T_STATIC:
                  $gbdPHPNewCode .= $token[1]. gbdAddUntilNext($gbdThisScript, $gbdTokens, ';') . ';';
                  next($gbdTokens);
                  break;

               case T_INTERFACE:             
               case T_CATCH:   
               case T_THROW:  
                  $gbdPHPNewCode .= $token[1]. gbdAddUntilNext($gbdThisScript, $gbdTokens, '{');
                  break;
                  
               case T_CLASS:
                  if($gbdRedefineFuncs) {
                     gbdIfNextIs($gbdTokens, $whitespace, '{');
                     $gbdTmp = gbdAddUntilNext($gbdThisScript, $gbdTokens, '{');
                     $gbdTmpClassnam = preg_split("/[^a-zA-Z0-9_\x7f-\xff]/", $gbdTmp);

                     if(class_exists($gbdTmpClassnam[0]) || $debug)
                        $gbdPHPNewCode .= $token[1]. $whitespace . $gbdRedefineFuncs . $gbdTmp;
                     else
                        $gbdPHPNewCode .= $token[1]. $whitespace . $gbdTmp;
                  } else {
                     $gbdPHPNewCode .= $token[1]. gbdAddUntilNext($gbdThisScript, $gbdTokens, '{');
                  }
                  
                  break;
               case T_FUNCTION:
                  if($gbdRedefineFuncs) {
                     gbdIfNextIs($gbdTokens, $whitespace, '{');
                     $gbdTmp = gbdAddUntilNext($gbdThisScript, $gbdTokens, '{');
                        
                     $gbdTmpClassnam = preg_split("/[^a-zA-Z0-9_\x7f-\xff]/", $gbdTmp);
                     if(function_exists($gbdTmpClassnam[0]) || $debug) {
                     
                        if(substr($gbdTmp, 0, 1) == '&') {
                           $gbdTmp = ltrim(substr($gbdTmp, 1));
                           $whitespace .= ' &';
                        }
                        $gbdPHPNewCode .= $token[1]. $whitespace . $gbdRedefineFuncs . $gbdTmp;
                     } else
                        $gbdPHPNewCode .= $token[1]. $whitespace . $gbdTmp;
                  } else {
                     $gbdPHPNewCode .= $token[1]. gbdAddUntilNext($gbdThisScript, $gbdTokens, '{');
                  }
                  break;
               
               case T_COMMENT:
               case T_ML_COMMENT:
               case T_DOC_COMMENT:
               case T_WHITESPACE:
                  $gbdPHPNewCode .= $token[1];
                  break;
                  
               case T_IF:
                  if($gbdOne == gbdCOLONIF) {
                     prev($gbdTokens);
                     $gbdPHPNewCode .= gbdParseBlock($gbdThisScript, $gbdTokens, gbdONESTATEMENT, $debug, $gbdRedefineFuncs) ;
                     break;
                     
                  }
                  $gbdPHPNewCode .= ' <gbdGubed> ' . $token[1] . gbdAddUntilNext($gbdThisScript, $gbdTokens, '(');
                  $gbdPHPNewCode .= gbdAddBlock($gbdThisScript, $gbdTokens, '(', ')');
                  if(gbdIfNextIs($gbdTokens, $whitespace, '{')) {
                     next($gbdTokens);
                     $gbdPHPNewCode .= $whitespace . '{'. gbdParseBlock($gbdThisScript, $gbdTokens, gbdBLOCK, $debug, $gbdRedefineFuncs) ;
                  } elseif(gbdIfNextIs($gbdTokens, $whitespace2, ':')) {
                     next($gbdTokens);
                     $gbdPHPNewCode .= $whitespace . '{'. gbdParseBlock($gbdThisScript, $gbdTokens, gbdCOLONIF, $debug, $gbdRedefineFuncs) . '}' ;
                  } else {
                     $gbdPHPNewCode .= $whitespace . '{' . gbdParseBlock($gbdThisScript, $gbdTokens, gbdONESTATEMENT, $debug, $gbdRedefineFuncs) . '}';
                  }
                  If(!gbdIfNextIs($gbdTokens, $whitespace, T_ELSE)
                  && !gbdIfNextIs($gbdTokens, $whitespace, T_ELSEIF)) {
                     gbdRevertWhitespace($gbdTokens);
                     if($gbdOne == gbdONESTATEMENT)
                        return $gbdPHPNewCode . '<gbdEndGubed>';
                     $gbdPHPNewCode .= '<gbdEndGubed>';
                  } else
                     gbdRevertWhitespace($gbdTokens);
                  break;

               case T_FOR:
                  $gbdPHPNewCode .= ' <gbdGubed> ' . $token[1] . gbdAddUntilNext($gbdThisScript, $gbdTokens, '(');
                  
                  $gbdPHPNewCode .= gbdAddBlock($gbdThisScript, $gbdTokens, '', ';');
                  $gbdPHPNewCode .= gbdAddBlock($gbdThisScript, $gbdTokens, '', ';');
                 
                  //get up to next right paren
                  $gbdPHPTempCode = gbdAddBlock($gbdThisScript, $gbdTokens, '', ')');
                  $numLeftParens = substr_count($gbdPHPTempCode, '(');
                  if(trim($gbdPHPTempCode) == ')')
                     $gbdPHPTempCode = 'true)';
                  $gbdPHPNewCode .= ' <gbdGubed2> ' . $gbdPHPTempCode;

                  if($numLeftParens == 1) {
                     //match the right paren of the for statement
                     $gbdPHPNewCode .=  gbdAddBlock($gbdThisScript, $gbdTokens, '', ')');
                  }
                  else if($numLeftParens > 1) {
                      //loop to match the number of left parens
                     for($parenCounter = 1; $parenCounter <= $numLeftParens; $parenCounter++)
                        $gbdPHPNewCode .=  gbdAddBlock($gbdThisScript, $gbdTokens, '', ')');
                  }
                     
                  if(gbdIfNextIs($gbdTokens, $whitespace, '{') || gbdIfNextIs($gbdTokens, $whitespace2, ':')) {
                     next($gbdTokens);
                     $gbdPHPNewCode .= $whitespace . '{'. gbdParseBlock($gbdThisScript, $gbdTokens, gbdBLOCK, $debug, $gbdRedefineFuncs) ;
                  } else {
                     $gbdPHPNewCode .= $whitespace . '{' . gbdParseBlock($gbdThisScript, $gbdTokens, gbdONESTATEMENT, $debug, $gbdRedefineFuncs) . '}';
                  }                    
                  if($gbdOne == gbdONESTATEMENT)
                     return $gbdPHPNewCode . '<gbdEndGubed>' ;
                  $gbdPHPNewCode .= '<gbdEndGubed>';   
                  break;

               case T_SWITCH:
               case T_WHILE:
               case T_FOREACH:
                  $gbdPHPNewCode .= ' <gbdGubed> ' . $token[1] . gbdAddUntilNext($gbdThisScript, $gbdTokens, '(');
                  $gbdPHPNewCode .= gbdAddBlock($gbdThisScript, $gbdTokens, '(', ')');
                     
                  if(gbdIfNextIs($gbdTokens, $whitespace, '{') || gbdIfNextIs($gbdTokens, $whitespace2, ':')) {
                     next($gbdTokens);
                     $gbdPHPNewCode .= $whitespace . '{'. gbdParseBlock($gbdThisScript, $gbdTokens, gbdBLOCK, $debug, $gbdRedefineFuncs) ;
                  } else {
                     $gbdPHPNewCode .= $whitespace . '{' . gbdParseBlock($gbdThisScript, $gbdTokens, gbdONESTATEMENT, $debug, $gbdRedefineFuncs) . '}';
                  }                    
                  if($gbdOne == gbdONESTATEMENT)
                     return $gbdPHPNewCode . '<gbdEndGubed>' ;
                  $gbdPHPNewCode .= '<gbdEndGubed>';   
                  break;
                  
               case T_DO:
                  $gbdPHPNewCode .= ' <gbdGubed> ' . $token[1];
                     
                  if(gbdIfNextIs($gbdTokens, $whitespace, '{') || gbdIfNextIs($gbdTokens, $whitespace2, ':')) {
                     next($gbdTokens);
                     $gbdPHPNewCode .= $whitespace . '{'. gbdParseBlock($gbdThisScript, $gbdTokens, gbdBLOCK, $debug, $gbdRedefineFuncs) ;
                  } else {
                     $gbdPHPNewCode .= $whitespace . '{' . gbdParseBlock($gbdThisScript, $gbdTokens, gbdONESTATEMENT, $debug, $gbdRedefineFuncs) . '}';
                  }                    
                  $gbdPHPNewCode  .= gbdAddUntilNext($gbdThisScript, $gbdTokens, '(');
                  $gbdPHPNewCode .= gbdAddBlock($gbdThisScript, $gbdTokens, '(', ')');
                  if($gbdOne == gbdONESTATEMENT)
                     return $gbdPHPNewCode . '<gbdEndGubed>' ;
                  $gbdPHPNewCode .= '<gbdEndGubed>';   
                  break;
               
  
               case T_ELSE:
                  if($gbdOne == gbdCOLONIF) {
                        prev($gbdTokens);
                        return $gbdPHPNewCode;
                  }
                  $gbdPHPNewCode .= $token[1];
                  if(gbdIfNextIs($gbdTokens, $whitespace, T_IF)) {
                     $gbdPHPNewCode .= $whitespace . gbdAddUntilNext($gbdThisScript, $gbdTokens, '(');
                     $gbdPHPNewCode .= gbdAddBlock($gbdThisScript, $gbdTokens, '(', ')');

                     if(gbdIfNextIs($gbdTokens, $whitespace, '{') ) {
                        next($gbdTokens);
                        $gbdPHPNewCode .= $whitespace . '{'. gbdParseBlock($gbdThisScript, $gbdTokens, gbdBLOCK, $debug, $gbdRedefineFuncs)  ;
                     } elseif(gbdIfNextIs($gbdTokens, $whitespace2, ':')) {
                        next($gbdTokens);
                        $gbdPHPNewCode .= $whitespace . '{'. gbdParseBlock($gbdThisScript, $gbdTokens, gbdCOLONIF, $debug, $gbdRedefineFuncs) . '}' ;
                     } else {
                        $gbdPHPNewCode .= $whitespace . ' {' . gbdParseBlock($gbdThisScript, $gbdTokens, gbdONESTATEMENT, $debug, $gbdRedefineFuncs) . '}';
                     }
                     If($gbdOne == gbdONESTATEMENT
                     && !gbdIfNextIs($gbdTokens, $whitespace, T_ELSE)
                     && !gbdIfNextIs($gbdTokens, $whitespace, T_ELSEIF)) {
                        gbdRevertWhitespace($gbdTokens);
                        return $gbdPHPNewCode . '<gbdEndGubed>';
                     } else
                        gbdRevertWhitespace($gbdTokens);
                                       
                  } else {
                     $gbdPHPNewCode .= $whitespace;
                     if(gbdIfNextIs($gbdTokens, $whitespace, '{')) {
                        next($gbdTokens);
                        $gbdPHPNewCode .= $whitespace . '{'. gbdParseBlock($gbdThisScript, $gbdTokens, gbdBLOCK, $debug, $gbdRedefineFuncs)  ;
                     } elseif(gbdIfNextIs($gbdTokens, $whitespace2, ':')) {
                        next($gbdTokens);
                        $gbdPHPNewCode .= $whitespace . '{'. gbdParseBlock($gbdThisScript, $gbdTokens, gbdCOLONIF, $debug, $gbdRedefineFuncs) . '}' ;
                     } else {
                        $gbdPHPNewCode .= $whitespace . ' {' . gbdParseBlock($gbdThisScript, $gbdTokens, gbdONESTATEMENT, $debug, $gbdRedefineFuncs) . '}';
                     }
                     If($gbdOne == gbdONESTATEMENT)
                        return $gbdPHPNewCode . '<gbdEndGubed>' ;
                     $gbdPHPNewCode .= '<gbdEndGubed>';
                  }
                  

                  break;

               case T_ELSEIF:
                  if($gbdOne == gbdCOLONIF) {
                     prev($gbdTokens);
                     return $gbdPHPNewCode;
                  }
                  $gbdPHPNewCode .=  $token[1] . gbdAddUntilNext($gbdThisScript, $gbdTokens, '(')
                                 .   gbdAddBlock($gbdThisScript, $gbdTokens, '(', ')');
                  if(gbdIfNextIs($gbdTokens, $whitespace, '{')) {
                     next($gbdTokens);
                     $gbdPHPNewCode .=  $whitespace . '{'. gbdParseBlock($gbdThisScript, $gbdTokens, gbdBLOCK, $debug, $gbdRedefineFuncs)  ;
                  } elseif(gbdIfNextIs($gbdTokens, $whitespace2, ':')) {
                     next($gbdTokens);
                     $gbdPHPNewCode .= $whitespace . '{'. gbdParseBlock($gbdThisScript, $gbdTokens, gbdCOLONIF, $debug, $gbdRedefineFuncs) . '}' ;
                  } else {
                     $gbdPHPNewCode .=  $whitespace . ' {' . gbdParseBlock($gbdThisScript, $gbdTokens, gbdONESTATEMENT, $debug, $gbdRedefineFuncs) . '}';
                  }
                  If($gbdOne == gbdONESTATEMENT
                  && !gbdIfNextIs($gbdTokens, $whitespace, T_ELSE)
                  && !gbdIfNextIs($gbdTokens, $whitespace, T_ELSEIF)) {
                     gbdRevertWhitespace($gbdTokens);
                     return $gbdPHPNewCode . '<gbdEndGubed>' ;
                  } else
                     gbdRevertWhitespace($gbdTokens);
                  break;

               case T_ENDFOR:
               case T_ENDFOREACH:
               case T_ENDSWITCH:
               case T_ENDWHILE:
               case T_ENDDECLARE:
                  $gbdPHPNewCode .= '}';
                  return $gbdPHPNewCode;
                  
               case T_ENDIF:
                  if($gbdOne != gbdCOLONIF) {
                     echo ":(\n";
                  }
                  return $gbdPHPNewCode;
                                                                   
               case T_END_HEREDOC:
                  $gbdPHPNewCode .= str_replace(';', '', $token[1]) . "\n";
                  break;
               
               case T_OPEN_TAG_WITH_ECHO:
                  $gbdOpenTags++;
                  $gbdPHPNewCode .= str_replace('=', '', $token[1]). '} <gbdGubed> echo ';
                  prev($gbdTokens);
                  $gbdPHPNewCode .= substr(ltrim(gbdAddBlock($gbdThisScript, $gbdTokens, '', T_CLOSE_TAG, false)), 3);
                  $gbdPHPNewCode .= ' <gbdEndGubed> ;'; 
                  break;
                  
               case T_OPEN_TAG:
                  $gbdOpenTags++;
                  $gbdTmp = '';
                  if(gbdIfNextIs($gbdTokens, $whitespace, T_STRING, $gbdTmp) && $whitespace == '') {
                     if(isset($gbdTmp[1])) {
                        if(strtolower($gbdTmp[1]) == 'php') {
                           $gbdPHPNewCode .= $token[1];
                           next($gbdTokens);
                           break;
                        }
                     }
                  }
                  $gbdPHPNewCode .= $token[1] . '}' . $whitespace;
                  break;
                  
               case T_CLOSE_TAG:
                  $gbdOpenTags--; 

                  // We add a ? >< ? to handle // comments with a ? > in the end
                  $gbdPHPNewCode .= ' ?><?php <gbdGubed> {' . $token[1] ; 
                  break;
               
               case T_RETURN:
                  $gbdTmp = '';
                  if(gbdIfNextIs($gbdTokens, $whitespace, Array(T_INCLUDE, T_INCLUDE_ONCE, T_REQUIRE, T_REQUIRE_ONCE), $gbdTmp)) {
                     gbdAddUntilNext($gbdThisScript, $gbdTokens, Array('(', '"'));
                     $gbdPHPNewCode .= ' <gbdGubed> { $GLOBALS[\'gbd\'][\'gbdNoHalt\'] = true; $gbdInclude = '
                                                . gbdAddUntilNext($gbdThisScript, $gbdTokens, Array(';', T_CLOSE_TAG));

                     if($gbdTmp == T_INCLUDE || $gbdTmp == T_INCLUDE_ONCE)
                        $gbdPHPNewCode .= ' ;$gbdIncludeRequire = \'include\';';  
                     else
                        $gbdPHPNewCode .= ' ;$gbdIncludeRequire = \'require\';';
                        
                     if($gbdTmp == T_REQUIRE_ONCE || $gbdTmp == T_INCLUDE_ONCE)
                        $gbdPHPNewCode .= '$GLOBALS[\'gbd\'][\'gbdNoHalt\'] = false; include(\'GubedIncludeOnce.php\');' . $token[1] . ';}';
                     else
                        $gbdPHPNewCode .= '$GLOBALS[\'gbd\'][\'gbdNoHalt\'] = false; include(\'GubedInclude.php\');' . $token[1] . ';}';
                     
                  } else {
                     
                     $gbdPHPNewCode .= '<gbdGubed>' . $token[1] . $whitespace . gbdAddBlock($gbdThisScript, $gbdTokens, '', ';');
                     $gbdPHPNewCode = substr($gbdPHPNewCode, 0, strlen($gbdPHPNewCode ) - 1) . ' <gbdEndGubed> ;'; 
      
                     if($gbdOne == gbdONESTATEMENT)
                        return $gbdPHPNewCode;
                  }
                  break;
                     
               case T_INCLUDE:
                  $gbdPHPNewCode .= ' <gbdGubed> { $GLOBALS[\'gbd\'][\'gbdNoHalt\'] = true; $gbdInclude = '
                                 . gbdAddUntilNext($gbdThisScript, $gbdTokens, Array(';', T_CLOSE_TAG));
                  $gbdPHPNewCode .= ' ;$gbdIncludeRequire = \'include\';  $GLOBALS[\'gbd\'][\'gbdNoHalt\'] = false; include(\'GubedInclude.php\');} ';
                  break;
                  
               case T_INCLUDE_ONCE:
                  $gbdPHPNewCode .= ' <gbdGubed> { $GLOBALS[\'gbd\'][\'gbdNoHalt\'] = true; $gbdInclude = '
                                 . gbdAddUntilNext($gbdThisScript, $gbdTokens, Array(';', T_CLOSE_TAG))
                                 .' ;$gbdIncludeRequire = \'include\';  $GLOBALS[\'gbd\'][\'gbdNoHalt\'] = false; include(\'GubedIncludeOnce.php\');} ';
                  break;
               
               case T_REQUIRE:
                  $gbdPHPNewCode .= ' <gbdGubed> { $GLOBALS[\'gbd\'][\'gbdNoHalt\'] = true; $gbdInclude = '
                                 . gbdAddUntilNext($gbdThisScript, $gbdTokens, Array(';', T_CLOSE_TAG))
                                 .' ;$gbdIncludeRequire = \'require\';  $GLOBALS[\'gbd\'][\'gbdNoHalt\'] = false; include(\'GubedInclude.php\');} ';
                  break;
                  
               case T_REQUIRE_ONCE:   
                  $gbdPHPNewCode .= ' <gbdGubed> { $GLOBALS[\'gbd\'][\'gbdNoHalt\'] = true; $gbdInclude = '
                                 . gbdAddUntilNext($gbdThisScript, $gbdTokens, Array(';', T_CLOSE_TAG))
                                 .' ;$gbdIncludeRequire = \'require\'; $GLOBALS[\'gbd\'][\'gbdNoHalt\'] = false; include(\'GubedIncludeOnce.php\');} ';
                  break;
                  
               default:
                  if($debug) {
                     print(token_name($token[0]) . ": '" . htmlentities($token[1]) . "' \n");
                  }
                  $gbdPHPNewCode .= $token[1];
                  
            }
         } else {
            
            switch($token) {
               case ';':
                  $gbdPHPNewCode .= ' <gbdEndGubed>' . $token;
                  if($gbdOne == gbdONESTATEMENT)
                     return $gbdPHPNewCode;
                     
                  break;   
               
               case '{':   
                  $gbdPHPNewCode .= $token . gbdParseBlock($gbdThisScript, $gbdTokens, gbdBLOCK, $debug, $gbdRedefineFuncs);
                  break;
                  
               case '}':
                  $gbdPHPNewCode .= $token;
                  return $gbdPHPNewCode;
                     
               case ')':
               case ':':
                  $gbdPHPNewCode .=  $token;
                  break;
                                
               case '(':
               case '@':
               case '$':
               case '!':
                  $casetoken = $token;
                  list($k, $token) = each($gbdTokens);
                  if(in_array($token[0], Array(T_REQUIRE, T_REQUIRE_ONCE, T_INCLUDE, T_INCLUDE_ONCE))) {
                     prev($gbdTokens);

                  } else {
                     prev($gbdTokens);
                     $gbdPHPNewCode .= '<gbdGubed>' . $casetoken . gbdAddBlock($gbdThisScript, $gbdTokens, '', ';');
                     $gbdPHPNewCode = substr($gbdPHPNewCode, 0, strlen($gbdPHPNewCode ) -1) . ' <gbdEndGubed> ;'; 
                  
                     if($gbdOne  == gbdONESTATEMENT)
                        return $gbdPHPNewCode;
                  }
                  break;
              
              // Sometimes token_get_all() doesent parse the leading open tag correctly, this is hopefully a workaround
               case '<':  
                  if(gbdIfNextIs($gbdTokens, $whitespace, '?')) {
                     next($gbdTokens);
                    //echo "php bug\n";
                     $gbdOpenTags++;
                     if(gbdIfNextIs($gbdTokens, $whitespace, T_STRING, $gbdTmp) && $whitespace == '') {
                        if(strtolower($gbdTmp[1]) == 'php') {
                           $gbdPHPNewCode .= $token[1];
                           next($gbdTokens);
                           
                        }
                     }
                     $gbdPHPNewCode .= $token[1] . '<?php }';
                     break;
                  }
                  $gbdPHPNewCode .=  $token;
                  break;
                  
               default:   
                  if($debug) {
                     echo "{$token}\n";
                     //$gbdPHPNewCode .= '####';
                  }
                  $gbdPHPNewCode .=  $token;

            }
         }
         $gbdPrevToken = $token;
      }
         
      return $gbdPHPNewCode;
   }
   
   function gbdAddBlock($gbdThisScript, &$code, $start, $end, $includeend = true) {
   
      $ret = each($code);
      while(is_array($ret))
         $ret = $ret[1];

      if($ret == $end)
         return $ret;

      while(list($k, $token) = each($code)) {
         if(is_array($token)) {
//             print(token_name($token[0]) . ": '" . htmlentities($token[1]) . "'\n");
            
            if($token[0] == $end) {
               if($includeend)
                  $ret .= $token[1];
               else
                  prev($code);
                return $ret;
            }
            
            switch($token[0]) {
               case T_FILE:
                  $ret .= "'{$gbdThisScript}'";
                  break;
                  
               case T_CLOSE_TAG:
                  if($end == ';') {
                     $ret .= ';';
                     if(prev($code) === false) {
                        end($code);
                        prev($code);
                     }
                     return $ret;
                  } else
                     $ret .= $token[1];
                  break;
                  
               case T_START_HEREDOC:
                  $ret .= $token[1] . gbdAddUntilNext($gbdThisScript, $code, T_END_HEREDOC);
                  break;
                  
               case T_END_HEREDOC:
                  $ret .= str_replace(';', '', $token[1]) . "\n";
                  break;

               default:
                  $ret .= $token[1];
            }
         } else {
         
            if($token == $start) {
               prev($code);
               $ret .= gbdAddBlock($gbdThisScript, $code, $start, $end);
               
            } elseif($token == $end) {
               if($includeend)
                  $ret .= $token;
               else
                  prev($code);
                return $ret;
                
            } else
               $ret .= $token;
        } 
            
      }
      return $ret;
   }
   
   function gbdAddUntilNext($gbdThisScript, &$code, $type) {
      $ret = '';
      if(!is_array($type))
        $type = Array($type);
      
      while(list($k, $token) = each($code)) {
         if(is_array($token)) {
            if(in_array($token[0], $type))
               break;
            else if($token[0] == T_FILE)
               $ret .= "'{$gbdThisScript}'";
            else
               $ret .= $token[1];
         } else {
           if(in_array($token, $type))
               break;
            else
               $ret .= $token;
         }
      }
      prev($code);
      return $ret;
   }
   
   function gbdIfNextIs(&$code, &$whitespace, $next, $returninfo="") {
      $whitespace = '';
      //if(!is_array($next))
      //   $next = Array($next);
         
      while(list($k, $token) = each($code)) {
         
         $returninfo = is_array($token) ? $token[0] : $token;
         if(is_array($token)) {
               
            switch($token[0]) {
            
               case T_WHITESPACE:
               case T_COMMENT:
                  $whitespace .= $token[1];
                  break;
               
               default:
                  if(!prev($code)) {
                     end($code);
                     prev($code);
                  }
                  if(is_array($next) && in_array($token[0], $next))
                     return true;
                  else if($token[0] == $next)
                     return true;
                  else
                     return false;
            }         
         } else {
         
            if(!prev($code)) {
               end($code);
               prev($code);
            }
            
            if(is_array($next) && in_array($token[0], $next))
               return true;
            else if($token == $next)
               return true;
            else 
               return false;
         }
      }
      return false;   
   }
   
   function gbdRevertWhitespace(&$code) {
   
      for(;;) {
         $gbdtoken = prev($code);
         if(is_array($gbdtoken)) {
            if(!in_array($gbdtoken[0], Array(T_WHITESPACE, T_COMMENT)))
               break;
         } else
            break;
      }
      next($code);
      return;   
   }
?>