<?php echo '<?xml version="1.0" encoding="iso-8859-1"?>'; ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

   <head>
      <title>Variable Test</title>
      <meta name="GENERATOR" content="Quanta Plus" />
      <link rel="stylesheet" type="text/css" href="../../../default.css" />
   </head>
   <body>
      <h1>
         Variable test
      </h1>
      <p>
         This is simple testscript to test Gubed's variable handling. Watch, break on change, change value, etc.
      </p>
      <p>
         Starting with two nested for loops. Things to try:
      </p>
      <ul>
         <li>
            Put a conditional breakpoint to break when "$col == 5 &amp;&amp; $row == 2"
         </li>
      </ul>
      <ul>
         <li>
            Put a breakpoint before the loop, add $row and $col to the watch list and single step through the loop
         </li>
      </ul>
      <ul>
         <li>
            Put a breakpoint before the loop, changing $increaserow to 0, continue executing the script (it will be an eternal loop). Pausing at will and use skip or change $increaserow to get out of the loop.
         </li>
      </ul>
      <?php
         // Initialize some variables
         $maxrow = 10;
         $increaserow = 1;
         
         // Output a table
         echo "<table>";
         // Loop
         for($row = 0; $row < $maxrow; $row += $increaserow) {
            if($increaserow)
               echo "<tr>\n";
            for($col = 0; $col < 10; $col ++) {
               if($increaserow) {
                  echo "   <td>\n";
                  echo "      {$col}, {$row}\n";
                  echo "   </td>\n";
               }
            }
            if($increaserow)
               echo "</tr>\n";
         }
         echo "</table>";
      ?>
      <p>
         Next, we'll initialize some variables of different types to make sure they are displayed correctly in the watch list.
      </p>   
      <pre><?php
         // Viewing different variable types
         // Integer
         $intVar = 5;
         print_r($intVar);
         echo "\n";
         
         // Float
         $floatVar = 5.5;
         print_r($floatVar);
         echo "\n";
         
         // Boolean
         $boolVar = true;
         print_r($boolVar);
         echo "\n";
         
         // Array
         $arrayVar = Array(
                              "firstname" => "Tom",
                              "lastname" => "Waits",
                              "birthyear" => 1949,
                              "songs" => Array("Innocent When You Dream", "Christmas Card From A Hooker", "Chained Together For Life")
                           );
         print_r($arrayVar);
         echo "\n";
         
         // Nothingness
         $nullVar = NULL;
         print_r($nullVar);
         echo "\n";
        
      ?>
      </pre>
      <p>
         Last we'll output some server variables to make sure they are the same when we're debugging as when we're not:
      </p>
      <table>
         <tr>
            <td>Variable</td>
            <td>Value</td>
         </tr>
         <tr>
            <td>$_SERVER['PHP_SELF']</td>
            <td><?php echo $_SERVER['PHP_SELF']?></td>
         </tr>
         <tr>
            <td>$_SERVER['DOCUMENT_ROOT']</td>
            <td><?php echo $_SERVER['DOCUMENT_ROOT']?></td>
         </tr>
         <tr>
            <td>$_SERVER['SCRIPT_FILENAME']</td>
            <td><?php echo $_SERVER['SCRIPT_FILENAME']?></td>
         </tr>
         <tr>
            <td>$_SERVER['PATH_TRANSLATED']</td>
            <td><?php echo $_SERVER['PATH_TRANSLATED']?></td>
         </tr>
         <tr>
            <td>$_SERVER['SCRIPT_NAME']</td>
            <td><?php echo $_SERVER['SCRIPT_NAME']?></td>
         </tr>
         <tr>
            <td>$_SERVER['REQUEST_URI']</td>
            <td><?php echo $_SERVER['REQUEST_URI']?></td>
         </tr>
         <tr>
            <td>__FILE__</td>
            <td><?php echo __FILE__?></td>
         </tr>
         <tr>
            <td>__LINE__</td>
            <td><?php echo __LINE__?></td>
         </tr>
      </table>
   </body>
</html>
